magazine/src/Model/User/Entity/User/IdType.php
<?php

declare(strict_types=1);

namespace App\Model\User\Entity\User;

use Doctrine\DBAL\Platforms\AbstractPlatform;
use Doctrine\DBAL\Types\StringType;

class IdType extends StringType
{
    public const NAME = 'user_user_id';

    public function convertToDatabaseValue($value, AbstractPlatform $platform)
    {
        return $value instanceof Id ? $value->getValue() : $value;
    }

    public function convertToPHPValue($value, AbstractPlatform $platform)
    {
        return !empty($value) ? new Id($value) : null;
    }

    public function getName()
    {
        return self::NAME;
    }
}

magazine/src/Model/User/Entity/User/Name.php
<?php

declare(strict_types=1);

namespace App\Model\User\Entity\User;

use Webmozart\Assert\Assert;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Embeddable
 */
class Name
{
    /**
     * @var string
     * @ORM\Column(type="string")
     */
    private $first;

    /**
     * @var string
     * @ORM\Column(type="string")
     */
    private $last;

    /**
     * Name constructor.
     * @param string $first
     * @param string $last
     */
    public function __construct(string $first, string $last)
    {
        Assert::notEmpty($first);
        Assert::notEmpty($last);

        $this->first = $first;
        $this->last = $last;
    }

    /**
     * @return string
     */
    public function getFirst(): string
    {
        return $this->first;
    }

    /**
     * @return string
     */
    public function getLast(): string
    {
        return $this->last;
    }

    public function getFull(): string
    {
        return $this->first . ' ' . $this->last;
    }
}

magazine/src/Controller/Admin/OrderController.php
<?php

declare(strict_types=1);

namespace App\Controller\Admin;

use App\Model\Product\Entity\Order\Order;
use App\ReadModel\Product\OrderFetcher;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/admin", name="admin")
 * @IsGranted("ROLE_ADMIN")
 */
class OrderController extends AbstractController
{
    private const PER_PAGE = 10;

    /**
     * @Route("/orders", name=".orders")
     * @param Request $request
     * @param OrderFetcher $fetcher
     * @return Response
     */
    public function index(Request $request, OrderFetcher $fetcher): Response
    {
        $pagination = $fetcher->all(
            $request->query->getInt('page', 1),
            self::PER_PAGE,
            $request->query->get('sort', 'created'),
            $request->query->get('direction', 'desc')
        );

        return $this->render('admin/order/orders.html.twig', [
            'pagination' => $pagination,
        ]);
    }

    /**
     * @Route("/orders/{id}", name=".orders.show")
     * @param Order $order
     * @return Response
     */
    public function show(Order $order): Response
    {
        return $this->render('admin/order/show.html.twig', compact('order'));
    }
}

magazine/src/Controller/Profile/EmailController.php
<?php

declare(strict_types=1);

namespace App\Controller\Profile;

use App\Model\User\UseCase\Email;
use Psr\Log\LoggerInterface;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/profile/email")
 * @IsGranted("ROLE_USER")
 */
class EmailController extends AbstractController
{
    private $logger;

    public function __construct(LoggerInterface $logger)
    {
        $this->logger = $logger;
    }

    /**
     * @Route("", name="profile.email")
     * @param Request $request
     * @param Email\Request\Handler $handler
     * @return Response
     */
    public function request(Request $request, Email\Request\Handler $handler): Response
    {
        $command = new Email\Request\Command($this->getUser()->getId());

        $form = $this->createForm(Email\Request\Form::class, $command);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            try {
                $handler->handle($command);
                $this->addFlash('success', 'Check your email.');
                return $this->redirectToRoute('profile');
            } catch (\DomainException $e) {
                $this->logger->error($e->getMessage(), ['exception' => $e]);
                $this->addFlash('error', $e->getMessage());
            }
        }

        return $this->render('app/profile/email.html.twig', [
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{token}", name="profile.email.confirm")
     * @param string $token
     * @param Email\Confirm\Handler $handler
     * @return Response
     */
    public function confirm(string $token, Email\Confirm\Handler $handler): Response
    {
        $command = new Email\Confirm\Command($this->getUser()->getId(), $token);

        try {
            $handler->handle($command);
            $this->addFlash('success', 'Email is successfully changed.');
            return $this->redirectToRoute('profile');
        } catch (\DomainException $e) {
            $this->logger->error($e->getMessage(), ['exception' => $e]);
            $this->addFlash('error', $e->getMessage());
            return $this->redirectToRoute('profile');
        }
    }
}

magazine/src/Controller/Profile/NameController.php
<?php

declare(strict_types=1);

namespace App\Controller\Profile;

use App\Model\User\UseCase\Name\Command;
use App\Model\User\UseCase\Name\Form;
use App\Model\User\UseCase\Name\Handler;
use App\ReadModel\User\UserFetcher;
use Psr\Log\LoggerInterface;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/profile/name")
 * @IsGranted("ROLE_USER")
 */
class NameController extends AbstractController
{
    /**
     * @var UserFetcher
     */
    private $users;
    /**
     * @var LoggerInterface
     */
    private $logger;

    /**
     * NameController constructor.
     * @param $users
     * @param $logger
     */
    public function __construct(UserFetcher $users, LoggerInterface $logger)
    {
        $this->users = $users;
        $this->logger = $logger;
    }


    /**
     * @Route("", name="profile.name")
     * @param Request $request
     * @param Handler $handler
     * @return Response
     * @throws \Doctrine\ORM\EntityNotFoundException
     */
    public function edit(Request $request, Handler $handler): Response
    {
        $user = $this->users->getDetail($this->getUser()->getId());

        $command = new Command($user->id);
        $command->firstName = $user->first_name;
        $command->lastName = $user->last_name;

        $form = $this->createForm(Form::class, $command);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            try {
                $handler->handle($command);
                return $this->redirectToRoute('profile');
            } catch (\DomainException $e) {
                $this->logger->error($e->getMessage(), ['exception' => $e]);
                $this->addFlash('error', $e->getMessage());
            }
        }

        return $this->render('app/profile/name.html.twig', [
            'form' => $form->createView(),
        ]);
    }


}

magazine/src/Controller/Profile/OAuth/Facebook/DetachController.php
<?php

declare(strict_types=1);

namespace App\Controller\Profile\OAuth\Facebook;

use App\Model\User\UseCase\Network\Detach\Command;
use App\Model\User\UseCase\Network\Detach\Handler;
use Psr\Log\LoggerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/profile/oauth")
 */
class DetachController extends AbstractController
{
    private $logger;

    /**
     * DetachController constructor.
     * @param $logger
     */
    public function __construct(LoggerInterface $logger)
    {
        $this->logger = $logger;
    }

    /**
     * @Route("/detach/{network}/{identity}", name="profile.oauth.detach", methods={"DELETE"})
     * @param Request $request
     * @param string $network
     * @param string $identity
     * @param Handler $handler
     * @return Response
     */
    public function connect(Request $request, string $network, string $identity, Handler $handler): Response
    {
        if (!$this->isCsrfTokenValid('delete', $request->request->get('token'))) {
            return $this->redirectToRoute('profile');
        }

        $command = new Command(
            $this->getUser()->getId(),
            $network,
            $identity
        );

        try {
            $handler->handle($command);
            return $this->redirectToRoute('profile');
        } catch (\DomainException $e) {
            $this->logger->error($e->getMessage(), ['exception' => $e]);
            $this->addFlash('error', $e->getMessage());
            return $this->redirectToRoute('profile');
        }
    }

}

magazine/src/Controller/Profile/OAuth/Facebook/FacebookController.php
<?php

declare(strict_types=1);

namespace App\Controller\Profile\OAuth\Facebook;

use App\Model\User\UseCase\Network\Attach\Command;
use App\Model\User\UseCase\Network\Attach\Handler;
use KnpU\OAuth2ClientBundle\Client\ClientRegistry;
use Psr\Log\LoggerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/profile/oauth/facebook")
 */
class FacebookController extends AbstractController
{
    private $logger;

    /**
     * FacebookController constructor.
     * @param $logger
     */
    public function __construct(LoggerInterface $logger)
    {
        $this->logger = $logger;
    }

    /**
     * @Route("/attach", name="profile.oauth.facebook")
     * @param ClientRegistry $clientRegistry
     * @return Response
     */
    public function connect(ClientRegistry $clientRegistry): Response
    {
        return $clientRegistry
            ->getClient('facebook_attach')
            ->redirect(['public_profile']);
    }

    /**
     * @Route("/check", name="profile.oauth.facebook_check")
     * @param ClientRegistry $clientRegistry
     * @param Handler $handler
     * @return Response
     * @throws \Doctrine\ORM\EntityNotFoundException
     * @throws \Doctrine\ORM\NonUniqueResultException
     */
    public function check(ClientRegistry $clientRegistry, Handler $handler): Response
    {
        $client = $clientRegistry->getClient('facebook_attach');

        $command = new Command(
            $this->getUser()->getId(),
            'facebook',
            $client->fetchUser()->getId()
        );

        try {
            $handler->handle($command);
            $this->addFlash('success', 'Facebook is successfully attached.');
            return $this->redirectToRoute('profile');
        } catch (\DomainException $e) {
            $this->logger->error($e->getMessage(), ['exception' => $e]);
            $this->addFlash('error', $e->getMessage());
            return $this->redirectToRoute('profile');
        }
    }


}

magazine/src/Controller/Profile/OAuth/Google/DetachController.php
<?php

declare(strict_types=1);

namespace App\Controller\Profile\OAuth\Google;

use App\Model\User\UseCase\Network\Detach\Command;
use App\Model\User\UseCase\Network\Detach\Handler;
use Psr\Log\LoggerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/profile/oauth")
 */
class DetachController extends AbstractController
{
    private $logger;

    /**
     * DetachController constructor.
     * @param $logger
     */
    public function __construct(LoggerInterface $logger)
    {
        $this->logger = $logger;
    }

    /**
     * @Route("/detach/{network}/{identity}", name="profile.oauth.detach", methods={"DELETE"})
     * @param Request $request
     * @param string $network
     * @param string $identity
     * @param Handler $handler
     * @return Response
     */
    public function connect(Request $request, string $network, string $identity, Handler $handler): Response
    {
        if (!$this->isCsrfTokenValid('delete', $request->request->get('token'))) {
            return $this->redirectToRoute('profile');
        }

        $command = new Command(
            $this->getUser()->getId(),
            $network,
            $identity
        );

        try {
            $handler->handle($command);
            return $this->redirectToRoute('profile');
        } catch (\DomainException $e) {
            $this->logger->error($e->getMessage(), ['exception' => $e]);
            $this->addFlash('error', $e->getMessage());
            return $this->redirectToRoute('profile');
        }
    }

}

magazine/src/Controller/Profile/OAuth/Google/GoogleController.php
<?php

declare(strict_types=1);

namespace App\Controller\Profile\OAuth\Google;

use App\Model\User\UseCase\Network\Attach\Command;
use App\Model\User\UseCase\Network\Attach\Handler;
use KnpU\OAuth2ClientBundle\Client\ClientRegistry;
use Psr\Log\LoggerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/profile/oauth/google")
 */
class GoogleController extends AbstractController
{
    private $logger;

    /**
     * FacebookController constructor.
     * @param $logger
     */
    public function __construct(LoggerInterface $logger)
    {
        $this->logger = $logger;
    }

    /**
     * @Route("/attach/google", name="profile.oauth.google")
     * @param ClientRegistry $clientRegistry
     * @return Response
     */
    public function connect(ClientRegistry $clientRegistry): Response
    {
        return $clientRegistry
            ->getClient('google_attach')
            ->redirect(['https://www.googleapis.com/auth/userinfo.profile']);
    }

    /**
     * @Route("/check", name="profile.oauth.google_check")
     * @param ClientRegistry $clientRegistry
     * @param Handler $handler
     * @return Response
     * @throws \Doctrine\ORM\EntityNotFoundException
     * @throws \Doctrine\ORM\NonUniqueResultException
     */
    public function check(ClientRegistry $clientRegistry, Handler $handler): Response
    {
        $client = $clientRegistry->getClient('google_attach');

        $command = new Command(
            $this->getUser()->getId(),
            'google',
            $client->fetchUser()->getId()
        );

        try {
            $handler->handle($command);
            $this->addFlash('success', 'Google is successfully attached.');
            return $this->redirectToRoute('profile');
        } catch (\DomainException $e) {
            $this->logger->error($e->getMessage(), ['exception' => $e]);
            $this->addFlash('error', $e->getMessage());
            return $this->redirectToRoute('profile');
        }
    }


}

magazine/src/Controller/Profile/OrderController.php
<?php

declare(strict_types=1);

namespace App\Controller\Profile;

use App\Model\Product\Entity\Order\Order;
use App\ReadModel\Product\OrderFetcher;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Response;

/**
 * @IsGranted("ROLE_USER")
 */
class OrderController extends AbstractController
{
    /**
     * @Route("/profile/orders", name="profile.orders")
     * @param OrderFetcher $fetcher
     * @return Response
     */
    public function index(OrderFetcher $fetcher): Response
    {
        $orders = $fetcher->forCustomer($this->getUser()->getId());
        return $this->render('app/profile/orders/orders.html.twig', compact('orders'));
    }

    /**
     * @Route("/profile/orders/{id}", name="profile.orders.show")
     * @param Order $order
     * @return Response
     */
    public function show(Order $order): Response
    {
        if ($order->getCustomer()->getId() == $this->getUser()->getId()) {
            return $this->render('app/profile/orders/show.html.twig', compact('order'));
        }
        return $this->redirectToRoute('profile.orders');
    }
}

magazine/src/Controller/Profile/ShowController.php
<?php

declare(strict_types=1);

namespace App\Controller\Profile;

use App\ReadModel\User\UserFetcher;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @IsGranted("ROLE_USER")
 */
class ShowController extends AbstractController
{
    private $users;

    /**
     * ShowController constructor.
     * @param $users
     */
    public function __construct(UserFetcher $users)
    {
        $this->users = $users;
    }

    /**
     * @Route("/profile", name="profile")
     * @return Response
     */
    public function index(): Response
    {
        $user = $this->users->get($this->getUser()->getId());

        return $this->render('app/profile/show.html.twig', compact('user'));
    }
}

magazine/templates/app/profile/orders/orders.html.twig
{% extends 'base.html.twig' %}

{% block title %}Profile{% endblock %}

{% block breadcrumbs %}
    <div class="mybreadcrumb">
        <div class="container">
            <ul class="breadcrumbs">
                <li class="home">
                    <a href="{{ path('home') }}" title="Go to Home Page"><img
                                src="{{ asset('/build/images/home.png') }}" alt="Home"/></a>&nbsp;
                    <span>&gt;</span>
                </li>
                <li>
                    <a href="{{ path('profile') }}">Profile</a>
                    <span>&gt;</span>
                </li>
                <li>
                    <span class="grey">&nbsp;Orders&nbsp;</span>
                </li>
            </ul>
            <ul class="previous">
                <li><a href="{{ app.request.headers.get('referer') }}">Back to Previous Page</a></li>
            </ul>
            <div class="clearfix"></div>
        </div>
    </div>
{% endblock %}

{% block body %}

    <div class="container">
        <div class="card">
            <div class="card-body">
                <div class="box">
                    <table class="table table-bordered table-hover">
                        <thead>
                        <tr>
                            <th>Created</th>
                            <th>Grand total</th>
                            <th>Quantity of goods</th>
                            <th>Status</th>
                            <th></th>
                        </tr>
                        </thead>
                        <tbody>
                        {% for order in orders %}
                            <tr>
                                <td>{{ order['created'] }}</td>
                                <td>{{ order['grand_total'] }}</td>
                                <td>{{ order['count'] }}</td>
                                <td>{{ order['status'] }}</td>
                                <td>
                                    <div class="d-flex flex-row">
                                        <a href="{{ path('profile.orders.show', {'id': order['id']}) }}">Details</a>
                                    </div>
                                </td>
                            </tr>
                        {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

{% endblock %}

magazine/templates/app/profile/orders/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Profile{% endblock %}

{% block breadcrumbs %}
    <div class="mybreadcrumb">
        <div class="container">
            <ul class="breadcrumbs">
                <li class="home">
                    <a href="{{ path('home') }}" title="Go to Home Page"><img
                                src="{{ asset('/build/images/home.png') }}" alt="Home"/></a>&nbsp;
                    <span>&gt;</span>
                </li>
                <li>
                    <a href="{{ path('profile') }}">Profile</a>
                    <span>&gt;</span>
                </li>
                <li>
                    <a href="{{ path('profile.orders') }}">Orders</a>
                    <span>&gt;</span>
                </li>
                <li>
                    <span class="grey">&nbsp;{{ order.created|date('Y-m-d') }}&nbsp;</span>
                </li>
            </ul>
            <ul class="previous">
                <li><a href="{{ app.request.headers.get('referer') }}">Back to Previous Page</a></li>
            </ul>
            <div class="clearfix"></div>
        </div>
    </div>
{% endblock %}

{% block body %}

    <div class="container">
        <div class="card">
            <div class="card-body">
                <div class="box">
                    <table class="table table-bordered table-hover">
                        <tbody>
                        <tr>
                            <th>Created</th>
                            <td>
                                {{ order.created|date('Y-m-d') }}
                            </td>
                        </tr>
                        <tr>
                            <th>Grand total</th>
                            <td>
                                {{ order.grandTotal }}
                            </td>
                        </tr>
                        <tr>
                            <th>Status</th>
                            <td>
                                {{ order.status }}
                            </td>
                        </tr>
                        </tbody>
                    </table>
                </div>
            </div>
            <h4>Products</h4>
            <div class="box">
                <table class="table table-bordered table-hover">
                    <thead>
                    <tr>
                        <th>Name</th>
                        <th>Price</th>
                        <th>Count</th>
                        <th>Subtotal</th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for item in order.items %}
                        <tr>
                            <td>
                                <a href="{{ path('shop.men.product', {'id': item.product.id}) }}">{{ item.product.name }}</a>
                            </td>
                            <td>
                                {{ item.product.price }}
                            </td>
                            <td>
                                {{ item.quantity }}
                            </td>
                            <td>
                                {{ item.subtotal }}
                            </td>
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
            </div>
            <h4>Address</h4>
            <div class="box">
                <table class="table table-bordered table-hover">
                    <thead>
                    <tr>
                        <th>Name</th>
                        <th>Address</th>
                        <th>City</th>
                        <th>ZipCode</th>
                        <th>Country</th>
                    </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td>
                                {{ order.customer.name.full }}
                            </td>
                            <td>
                                {{ order.address.address }}
                            </td>
                            <td>
                                {{ order.address.city }}
                            </td>
                            <td>
                                {{ order.address.zipcode }}
                            </td>
                            <td>
                                {{ order.address.country }}
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>

{% endblock %}